<template>
  <div>
    <br>
    <legend>Datos del encargo actual.</legend>
    <div class="row">
      <div class="col-md-8 form-group">
        <label class="control-label"> Ente público </label><br>
        <el-select clearable class="select-default" filterable name="ente" v-validate="modelValidations.ente" placeholder="Ente" v-model="model.ente_publico_id">
          <el-option v-for="option in entes" class="select-default" :value="option.id" :label="option.valor" :key="option.valor">
          </el-option>
        </el-select>
        <small class="text-danger" v-show="ente.invalid">
          {{ getError('ente') }}
        </small>
      </div>
      <div class="col-md-4 form-group" v-if="mostrarCampos">
        <label class="control-label"> Nivel/Orden de Gobierno: </label>
        <br>
        <el-select clearable class="select-default" placeholder="Nivel" name="nivel_orden" v-validate="modelValidations.nivel_orden" v-model="model.nivel_gobierno_id">
          <el-option v-for="option in niveles" class="select-default" :value="option.id" :label="option.valor" :key="option.codigo">
          </el-option>
        </el-select>
        <small class="text-danger" v-show="nivel_orden.invalid">
          {{ getError('nivel_orden') }}
        </small>
      </div>
      <div class="col-md-4 form-group" v-if="mostrarCampos">
        <label class="control-label"> Poder/Naturaleza jurídica </label><br>
        <el-select clearable class="select-default" placeholder="Poder" name="poder" v-validate="modelValidations.poder" v-model="model.poder_juridico_id">
          <el-option v-for="option in poderes" class="select-default" :value="option.id" :label="option.valor" :key="option.codigo">
          </el-option>
        </el-select>
        <small class="text-danger" v-show="poder.invalid">
          {{ getError('poder') }}
        </small>
      </div>
    </div>
    <div class="row">
      <div class="col-md-8 form-group">
        <label class="control-label"> Nombre del Empleo, Cargo o Comisión </label>
        <br>
        <input class="form-control" type="text" name="nombre_cargo" v-validate="modelValidations.nombre_cargo" v-model="model.empleo_cargo_comision" placeholder="Nombre del Cargo" />
        <small class="text-danger" v-show="nombre_cargo.invalid">
          {{ getError('nombre_cargo') }}
        </small>
      </div>
      <div class="col-md-4 form-group">
        <label class="control-label"> Contrato por honorarios. </label><br>
        <p-radio name="honorarios" v-validate="modelValidations.honorarios" v-model="model.contratado_honorarios" label="1">SI</p-radio>
        <p-radio name="honorarios" v-validate="modelValidations.honorarios" v-model="model.contratado_honorarios" label="2">NO</p-radio>
        <small class="text-danger" v-show="honorarios.invalid">
          {{ getError('honorarios') }}
        </small>
      </div>
    </div>
    <div class="row">
      <div class="col-md-4 form-group">
        <label class="control-label"> Nivel </label>
        <br>
        <input class="form-control" type="text" name="nivel" v-validate="modelValidations.nivel" v-model="model.nivel_encargo" placeholder="Nivel" />
        <small class="text-danger" v-show="nivel.invalid">
          {{ getError('nivel') }}
        </small>
      </div>
      <div class="col-md-4 form-group">
        <label class="control-label"> Área </label>
        <br>
        <input class="form-control" type="text" name="area" v-validate="modelValidations.area" v-model="model.area_adscripcion" placeholder="Area de adscripción" />
        <small class="text-danger" v-show="area.invalid">
          {{ getError('area') }}
        </small>
      </div>
      <div class="col-md-4 form-group">
        <label class="control-label"> Fecha de toma de Posesión </label>
        <br>
        <el-date-picker name="toma_posesion" value-format="dd-MM-yyyy" format="dd-MM-yyyy" v-validate="modelValidations.toma_posesion" v-model="model.fecha_posesion" :picker-options="opciones" type="date" placeholder="Selecciona">
        </el-date-picker>
        <small class="text-danger" v-show="toma_posesion.invalid">
          {{ getError('toma_posesion') }}
        </small>
      </div>
    </div>
    <domicilio v-model="n_domicilio" titulo="/Ubicación del Cargo"></domicilio>
    <br><br>
    <div class="row">
      <div class="col-md-8 form-group">
        <label class="control-label"> Teléfono Laboral </label>
        <input class="form-control" type="text" name="curp" v-model="model.telefono_laboral_numero" placeholder="Teléfono Laboral" />
      </div>
      <div class="col-md-2 form-group">
        <label class="control-label"> Ext </label>
        <input class="form-control" type="text" name="curp" v-model="model.telefono_laboral_extension" placeholder="Teléfono Laboral" />
      </div>
      <div class="col-md-4 form-group" v-if="mostrarCampos">
        <label class="control-label"> Correo Electrónico </label>
        <input class="form-control" type="text" name="correo_laboral" v-validate="modelValidations.correo_laboral" v-model="model.correo_laboral" placeholder="Correo Laboral" />
        <small class="text-danger" v-show="correo_laboral.invalid">
          {{ getError('correo_laboral') }}
        </small>
      </div>
      <div class="col-md-4 form-group" v-if="mostrarCampos">
        <label class="control-label"> Sector/Industria: </label>
        <el-select clearable class="select-default" placeholder="Sector" name="sector" filterable v-validate="modelValidations.sector" v-model="model.sector_industria_id">
          <el-option v-for="option in sectores" class="select-default" :value="option.id" :label="option.valor" :key="option.codigo">
          </el-option>
        </el-select>
        <small class="text-danger" v-show="sector.invalid">
          {{ getError('sector') }}
        </small>
      </div>
      <div class="col-md-4 form-group" v-if="modelexp.sector_industria_id ==11">
        <label class="control-label"> Otro Sector </label>
        <input class="form-control" type="text" name="otroSector" v-model="modelexp.otro_sector" placeholder="Otro Sector" />
      </div>
      <div class="col-sm-8 form-group">
        <label class="control-label"> Funciones Principales: </label>
        <el-select clearable multiple class="select-default" v-model="model.funcionesp" width="100%" name="funciones" v-validate="modelValidations.funciones" placeholder="Multiple Select">
          <el-option v-for="option in funciones_p" class="select-default" :value="option.id" :label="option.valor" :key="option.codigo">
          </el-option>
        </el-select>
        <small class="text-danger" v-show="funciones.invalid">
          {{ getError('funciones') }}
        </small>
      </div>
      <div class="col-md-8">
        <div class="form-group">
          <label class="control-label"> Otras funciones: </label>
          <input class="form-control" type="text" name="cargopuesto" v-model="model.otras_funciones" placeholder="Otras funciones" />
        </div>
      </div>
    </div>
    <br>
  </div>
</template>
<script>
  import {
    Tag,
    Select,
    DatePicker
  } from "element-ui";
  import {
    mapFields
  } from "vee-validate";
  import Domicilio from "../Domicilio.vue";
  export default {
    components: {
      [Tag.name]: Tag,
      [DatePicker.name]: DatePicker,
      Domicilio
    },
    computed: {
      ...mapFields(["correo_laboral", "ente", "nombre_cargo", "nivel", "poder", "honorarios", "nivel_orden", "area", "toma_posesion", "sector", "funciones", "ambitoexp", "nombreins", "unidadadm", "jerarqexp", "fechaingreso", "sectorexp", "cargopuesto"])
    },
    data() {
      return {
        opciones: {
          disabledDate(date) {
            return date > new Date();
          }
        },
        // grupo: null,
        mostrarCampos: false,
        ip_id: null,
        datePicker: "",
        poderes: {},
        niveles: {},
        funcionesArr: [],
        funcionesExpArr: [],
        list_experiencia: [],
        edit_item: null,
        add_item: false,
        entidadFed: null,
        municipios: null,
        localidades: null,
        localidad: null,
        paises: null,
        entes: {},
        ambitos: {},
        funciones_p: {},
        sectores: {},
        model: {
          fecha_posesion: ''
        },
        modelexp: {},
        n_domicilio: {},
        n_domicilio2: {},
        modelValidations: {
          correo_laboral: {
            email: true
          },
          ente: {
            required: true
          },
          nombre_cargo: {
            required: true
          },
          nivel: {
            required: true
          },
          poder: {
            required: true
          },
          honorarios: {
            required: true
          },
          nivel_orden: {
            required: true
          },
          area: {
            required: true
          },
          toma_posesion: {
            required: true
          },
          sector: {
            required: true
          },
          funciones: {
            required: true
          }
        },
        modelExp: {
          ambitoexp: {
            required: true
          },
          nombreins: {
            required: true
          },
          unidadadm: {
            required: true
          },
          jerarqexp: {
            required: true
          },
          cargopuesto: {
            required: true
          },
          fecha_ingreso: {
            required: true
          }
        },
        fields_list: ["acciones", {
          key: "ambito_id",
          label: "Ámbito",
          tdClass: "text-left"
        }, {
          key: "nivel_gobierno_id",
          label: "Nivel",
          tdClass: "text-left"
        }, {
          key: "poder_ente_id",
          label: "Poder Jurídico",
          tdClass: "text-left"
        }, {
          key: "nombre_institucion",
          label: "Nombre",
          tdClass: "text-left"
        }, {
          key: "unidad_administrativa",
          label: "Unidad",
          tdClass: "text-left"
        }, {
          key: "sector_industria_id",
          label: "Sector/Industria",
          tdClass: "text-left"
        }, {
          key: "jerarquia_rango",
          label: "Jerarquia",
          tdClass: "text-left"
        }, {
          key: "cargo_puesto",
          label: "Cargo/Puesto",
          tdClass: "text-left"
        }, {
          key: "fecha_ingreso",
          label: "Fecha Ingreso",
          tdClass: "text-left"
        }, {
          key: "fecha_salida",
          label: "Fecha Salida",
          tdClass: "text-left"
        }, {
          key: "direccion_pais_id",
          label: "País",
          tdClass: "text-left"
        }, {
          key: "direccion_entidad_federativa_id",
          label: "Entidad Federativa",
          tdClass: "text-left"
        }, {
          key: "direccion_municipio_id",
          label: "Municipio",
          tdClass: "text-left"
        }, {
          key: "direccion_cp",
          label: "CP",
          tdClass: "text-left"
        }, {
          key: "direccion_numext",
          label: "Num Ext",
          tdClass: "text-left"
        }, {
          key: "direccion_numint",
          label: "Num Int",
          tdClass: "text-left"
        }]
      };
    },
    mounted() {
      // this.grupo = this.getKey('grupo');
      this.ip_id = this.getId();
      this.getSectores();
      this.getPoderes();
      this.getNivelesG();
      this.getAmbitos();
      this.getFunciones();
      this.getInfLaboral();
      this.getExperiencia();
      this.getEntes();
      this.$http.get("entidadFed").then(response => {
        this.entidadFed = response.data.entidadfed;
      }, error => {
        this.Err(error);
      });
      this.$http.get("paises").then(response => {
        this.paises = response.data.pais;
      }, error => {
        this.Err(error);
      });
      this.$http.get("municipios").then(response => {
        this.municipios = response.data.municipios;
      }, error => {
        this.Err(error);
      });
    },
    watch: {
      n_domicilio2: {
        handler: function () {
          if (this.n_domicilio2) {
            this.modelexp.direccion_pais_id = this.n_domicilio2.pais ? this.n_domicilio2.pais : 150;
            this.modelexp.direccion_entidad_federativa_id = this.n_domicilio2.entidadF ? this.n_domicilio2.entidadF : "";
            this.modelexp.direccion_municipio_id = this.n_domicilio2.municipio ? this.n_domicilio2.municipio : "";
            this.modelexp.direccion_localidad_id = this.n_domicilio2.localidad ? this.n_domicilio2.localidad : "";
            this.modelexp.direccion_cp = this.n_domicilio2.cp ? this.n_domicilio2.cp : "";
            this.modelexp.direccion_numext = this.n_domicilio2.ext ? this.n_domicilio2.ext : "";
            this.modelexp.direccion_numint = this.n_domicilio2.int ? this.n_domicilio2.int : "";
            this.modelexp.direccion_colonia = this.n_domicilio2.colonia ? this.n_domicilio2.colonia : "";
          }
        },
        deep: true
      },
      n_domicilio: {
        handler: function () {
          if (this.n_domicilio) {
            this.model.direccion_encargo_pais_id = this.n_domicilio.pais ? this.n_domicilio.pais : 150;
            this.model.direccion_encargo_entidad_federativa_id = this.n_domicilio.entidadF ? this.n_domicilio.entidadF : "";
            this.model.direccion_encargo_municipio_id = this.n_domicilio.municipio ? this.n_domicilio.municipio : "";
            this.model.direccion_encargo_localidad_id = this.n_domicilio.localidad ? this.n_domicilio.localidad : "";
            this.model.direccion_encargo_cp = this.n_domicilio.cp ? this.n_domicilio.cp : "";
            this.model.direccion_vialidad_nombre = this.n_domicilio.vialidad_nombre;
            this.model.direccion_vialidad_tipo = this.n_domicilio.vialidad;
            this.model.direccion_encargo_numext = this.n_domicilio.ext ? this.n_domicilio.ext : "";
            this.model.direccion_encargo_numint = this.n_domicilio.int ? this.n_domicilio.int : "";
            this.model.direccion_encargo_colonia = this.n_domicilio.colonia ? this.n_domicilio.colonia : "";
          }
        },
        deep: true
      }
    },
    methods: {
      getError(fieldName) {
        return this.errors.first(fieldName);
      },
      validate() {
        return this.$validator.validateAll();
      },
      showItem() {
        this.add_item = !this.add_item;
      },
      getPais(index) {
        var resp = "México";
        if (this.paises) {
          this.paises.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      getMunicipio(index) {
        var resp = "";
        if (this.municipios) {
          this.municipios.forEach(function (item) {
            if (item.id == index) {
              resp = item.nom_mun;
              return resp;
            }
          });
        }
        return resp;
      },
      getAmbito(index) {
        var resp = "";
        if (this.ambitos) {
          this.ambitos.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      getPoder(index) {
        var resp = "";
        if (this.poderes) {
          this.poderes.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      getNivel(index) {
        var resp = "";
        if (this.niveles) {
          this.niveles.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      getSector(index) {
        var resp = "";
        if (this.sectores && index) {
          this.sectores.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      getEntidad(index) {
        var resp = " ";
        if (this.entidadFed) {
          this.entidadFed.forEach(function (item) {
            if (item.id == index) {
              resp = item.nom_ent;
              return resp;
            }
          });
        }
        return resp;
      },
      getEnte(index) {
        var resp = " ";
        if (this.entes) {
          this.entes.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      cancelEdit() {
        if (this.edit_item) {
          this.edit_item.item._rowVariant = "";
        }
        this.limpiaCampos();
        this.showItem();
        this.edit_item = null;
      },
      getInfLaboral() {
        var v = this;
        this.$http.get("encargoAct/" + this.ip_id).then(response => {
          if (response.data.informacion != null) {
            this.model = response.data.informacion;
            this.model.contratado_honorarios = String(this.model.contratado_honorarios);
            ///para tomar solo el dato correspondiente a la funcion
            $.each(response.data.informacion.funcionesp, function (key, value) {
              v.funcionesArr.push(value.funcion_id);
            });
            this.model.funcionesp = v.funcionesArr;
          }
          this.n_domicilio = {
            pais_id: this.model.direccion_encargo_pais_id,
            entidadF: this.model.direccion_encargo_entidad_federativa_id,
            municipio: this.model.direccion_encargo_municipio_id,
            colonia: v.model.direccion_encargo_colonia,
            cp: v.model.direccion_encargo_cp,
            localidad: v.model.direccion_encargo_localidad_id,
            ext: v.model.direccion_encargo_numext,
            int: v.model.direccion_encargo_numint,
            vialidad: v.model.direccion_vialidad_tipo,
            vialidad_nombre: v.model.direccion_vialidad_nombre
          };
        }, error => {
          this.StepError(error);
          console.log(error);
        });
      },
      getExperiencia() {
        var v = this;
        this.$http.get("expLaboral/" + this.ip_id).then(response => {
          this.list_experiencia = response.data.experiencia;
        }, error => {
          this.StepError(error);
          console.log(error);
        });
      },
      getEntes() {
        var v = this;
        this.$http.get("cat_ente_publico").then(response => {
          this.entes = response.data.entes_publicos;
        }, error => {
          this.StepError(error);
          console.log(error);
        });
      },
      getSafe(fn, defaultVal) {
        try {
          return fn();
        } catch (e) {
          return defaultVal;
        }
      },
      addItem() {
        this.$validator.validateAll().then(response => {
          if (response) {
            this.loadButton(this.$refs.btnSave);
            this.$http.put("expLaboral/" + this.ip_id, this.modelexp).then(response => {
              this.StepOk("Guardado");
              /* this.origen_tramites = JSON.parse(JSON.stringify(response.data.tramite));
                    eventBus.$emit("TramiteSaved", response.data.tramite);
                    this.envioRespuesta(true); */
              if (this.edit_item === undefined || this.edit_item === null) {
                this.list_experiencia.push({
                  ...this.modelexp
                });
              } else {
                this.list_experiencia.splice(this.edit_item.index, 1, this.modelexp);
                this.edit_item.item._rowVariant = "";
              }
              this.showItem();
              this.limpiaCampos();
              this.edit_item = null;
            }, error => {
              this.StepError(error);
              //this.change =  true;
            });
          } else {
            this.StepW("Hay campos sin completar");
          }
        });
      },
      editItem(indice) {
        this.showItem();
        this.edit_item = indice;
        this.modelexp = {
          ...this.list_experiencia[this.edit_item.index]
        };
        var v = this;
        $.each(this.modelexp.funciones, function (key, value) {
          v.funcionesExpArr.push(value.funcion_id);
        });
        this.modelexp.funcionesp = v.funcionesExpArr;
        this.editDomicilio();
        this.edit_item.item._rowVariant = "warning";
        $(".main-panel").animate({
          scrollTop: 1300
        }, 500, "swing");
      },
      removeItem(item) {
        if (this.list_experiencia[indice].id !== null) {
          let item = this.list_experiencia[indice];
          this.list_experiencia.splice(indice, 1);
          this.Ask("Desea borrar este registro", () => {
            this.$http.delete("expLaboral/" + item.id).then(response => {
              let index = this.list_experiencia.map(u => {
                return u.id;
              }).indexOf(item.id);
              this.list_experiencia.splice(index, 1);
              //this.filtro_direcciones = this.list_direcciones;
              /* eventBus.$emit("TramiteDelete", item); */
              this.OK("Registro eliminado");
            }, error => {
              this.Err(error);
            });
          });
        } else {
          this.Ask("Desea borrar este registro", () => {
            this.list_experiencia.splice(indice, 1);
          });
        }
      },
      limpiaCampos() {
        this.modelexp = {
          ambito_id: "",
          nivel_gobierno_id: "",
          poder_ente_id: "",
          nombre_institucion: "",
          unidad_administrativa: "",
          sector_industria_id: "",
          jerarquia_rango: "",
          cargo_puesto: "",
          fecha_ingreso: "",
          fecha_salida: "",
          funcionesp: "",
          otras_funciones: ''
        };
        this.n_domicilio2 = {
          pais: 150,
          entidadF: "",
          municipio: "",
          localidad: "",
          cp: "",
          colonia: "",
          vialidad: "",
          vialidad_nombre: "",
          ext: "",
          int: ""
        };
      },
      editDomicilio() {
        this.n_domicilio2.pais = this.modelexp.direccion_pais_id;
        this.n_domicilio2.entidadF = this.modelexp.direccion_entidad_federativa_id;
        this.n_domicilio2.municipio = this.modelexp.direccion_municipio_id;
        this.n_domicilio2.localidad = this.modelexp.direccion_localidad_id;
        this.n_domicilio2.cp = this.modelexp.direccion_cp;
        this.n_domicilio2.colonia = this.modelexp.direccion_colonia;
        this.n_domicilio2.vialidad = this.modelexp.direccion_vialidad_tipo;
        this.n_domicilio2.vialidad_nombre = this.modelexp.direccion_vialidad_nombre;
        this.n_domicilio2.ext = this.modelexp.direccion_numext;
        this.n_domicilio2.int = this.modelexp.direccion_numint;
      },
      showInput() {
        this.tags.inputVisible = true;
        this.$nextTick(() => {
          this.$refs.saveTagInput.$refs.input.focus();
        });
      },
      handleInputConfirm() {
        let inputValue = this.tags.inputValue;
        if (inputValue) {
          this.tags.dynamicTags.push(inputValue);
        }
        this.tags.inputVisible = false;
        this.tags.inputValue = "";
      },
      getPoderes() {
        this.$http.get("poderJuridico").then(response => {
          this.poderes = response.data.poderJuridico;
        }, error => {
          this.StepError(error);
          console.log(error);
        });
      },
      getNivelesG() {
        this.$http.get("nivelGobierno").then(response => {
          this.niveles = response.data.nivelGobierno;
        }, error => {
          this.StepError(error);
          console.log(error);
        });
      },
      getAmbitos() {
        this.$http.get("ambitos").then(response => {
          this.ambitos = response.data.ambitos;
        }, error => {
          this.StepError(error);
          console.log(error);
        });
      },
      getSectores() {
        this.$http.get("cat_sector_industria").then(response => {
          this.sectores = response.data.sectores;
        }, error => {
          this.StepError(error);
          console.log(error);
        });
      },
      getFunciones() {
        this.$http.get("funcPrinc").then(response => {
          this.funciones_p = response.data.funciones;
        }, error => {
          this.StepError(error);
          console.log(error);
        });
      }
    }
  };

</script>
<style>


</style>
